<#ibiztemplate>
TARGET=PSSYSAPP
</#ibiztemplate>
<#assign deploysys = sys.getName()?lower_case>
<#if sys.getDeploySysId()?? && (sys.getDeploySysId()?length lt 16)>
<#assign deploysys = sys.getDeploySysId()?lower_case>
</#if>
<#assign defaultApi = "api">
<#if app.getPSSysServiceAPI()??>
<#assign defaultApi = app.getPSSysServiceAPI().codeName?lower_case>
<#else>
<#if sys.getAllPSDevSlnMSDepAPIs()??>
    <#list sys.getAllPSDevSlnMSDepAPIs() as depSysApi>
        <#if depSysApi.getPSSysServiceAPI()?? >
            <#assign defaultApi = depSysApi.codeName?lower_case>
            <#break>
        </#if>
    </#list>
</#if>
</#if>
<#assign haswfentity=false>
<#list app.getAllPSAppDataEntities() as appDataEntity>
    <#assign psDataEntity=appDataEntity.getPSDataEntity()>
    <#if psDataEntity.hasPSDEWF()?? && psDataEntity.hasPSDEWF()==true>
        <#assign haswfentity=true>
        <#break>
    </#if>
</#list>
spring:
  cloud:
    gateway:
      discovery:
        locator:
          enabled: false
          lowerCaseServiceId: true
      routes: #配置网关路由规则
        <#if sys.getPSSystemSetting()?? && sys.getPSSystemSetting().getDataAccCtrlArch()?? && sys.getPSSystemSetting().getDataAccCtrlArch()==1>
        - id: cloud_uaa
          uri: lb://${r'${ibiz.ref.service.uaa:ibzuaa-api}'}
          order: 10
          predicates:
            -  Path=/v7/**,/uaa/**,/sysauthlogs
        - id: ibizcloud_ou
          uri: lb://${r'${ibiz.ref.service.ou:ibzou-api}'}
          order: 20
          predicates:
            - Path=/ibzemployees/**,/sysemployees/**,/ibzdepartments/**,/sysdepartments/**,/ibzorganizations/**,/sysorganizations/**
        - id: cloud_oss
          uri: lb://${r'${ibiz.ref.service.disk:ibzdisk-api}'}
          order: 40
          predicates:
            - Path=/ibizutil/**,/net-disk/**
        - id: cloud_conf
          uri: lb://${r'${ibiz.ref.service.conf:ibzuaa-api}'}
          order: 50
          predicates:
            - Path=/configs/**
        - id: cloud_dict
          uri: lb://${r'${ibiz.ref.service.dict:ibzdict-api}'}
          order: 60
          predicates:
            - Path=/dictionar**/**
        </#if>
        <#if haswfentity==true>
        - id: cloud_workflow
          uri: lb://${r'${ibiz.ref.service.wf:ibzwf-api}'}
          order: 30
          predicates:
            - Path=/wfcore/**
        </#if>
        <#assign serviceId="$"+"{ibiz.ref.service."+deploysys+"-"+defaultApi+":"+deploysys+"-"+defaultApi+"}">
        - id: gw-default-appdata
          uri: lb://${serviceId}
          order: 101
          predicates:
            - Path=/appdata<#if sys.getPSSystemSetting()?? && sys.getPSSystemSetting().getDataAccCtrlArch()?? && sys.getPSSystemSetting().getDataAccCtrlArch()==2>,/v7/**,/appdata/ibizutil/**,/configs/**</#if>

  <#list app.getAllPSAppDataEntities() as appDataEntity>
    <#assign serviceId="">
    <#assign serviceUrl=srfpluralize(appDataEntity.codeName?lower_case)>
    <#assign appEntity=appDataEntity.name?lower_case>
    <#assign psDataEntity=appDataEntity.getPSDataEntity()>
    <#assign systemName=sys.getCodeName()?lower_case>
  <#assign sybSysServiceType=(psDataEntity.getPSSubSysServiceAPI().getServiceType())!''>
  <#comment>服务类型为中台和MASA走自身处理</#comment>
    <#if psDataEntity.getStorageMode()==4 && (sybSysServiceType!='MIDDLEPLATFORM' && sybSysServiceType!='MASA')>
        <#comment>serviceApi模式</#comment>
        <#assign serviceId=(psDataEntity.getPSSubSysServiceAPI().getServiceCodeName())!''>
        <#assign serviceId="$"+"{ibiz.ref.service."+serviceId?lower_case+":"+serviceId+"}">
        <#assign serviceUrl=srfpluralize(appDataEntity.codeName?lower_case)>
        - id: ${appEntity}
          uri: lb://${serviceId}
          order: 200
          predicates:
            - Path=/${serviceUrl}/**
      <#else>
        <#assign sysApi = ''>
        <#if appDataEntity.getPSDEServiceAPI?? && appDataEntity.getPSDEServiceAPI()?? && appDataEntity.getPSDEServiceAPI().getPSSysServiceAPI?? && appDataEntity.getPSDEServiceAPI().getPSSysServiceAPI()??>
        <#assign sysApi=appDataEntity.getPSDEServiceAPI().getPSSysServiceAPI().codeName?lower_case>
        </#if> 
        <#assign serviceId="$"+"{ibiz.ref.service."+deploysys+"-"+sysApi+":"+deploysys+"-"+sysApi+"}">
        - id: ${appEntity}
          uri: lb://${serviceId}
          order: 200
          predicates:
            - Path=/${serviceUrl}/**
    </#if>
  </#list>
